<?php

namespace Bank\Mellat\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Bp ServiceType
 * @subpackage Services
 */
class Bp extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named bpRefundRequest
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Bank\Mellat\StructType\BpRefundRequest $parameters
     * @return \Bank\Mellat\StructType\BpRefundRequestResponse|bool
     */
    public function bpRefundRequest(\Bank\Mellat\StructType\BpRefundRequest $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->bpRefundRequest($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named bpSaleReferenceIdRequest
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Bank\Mellat\StructType\BpSaleReferenceIdRequest $parameters
     * @return \Bank\Mellat\StructType\BpSaleReferenceIdRequestResponse|bool
     */
    public function bpSaleReferenceIdRequest(\Bank\Mellat\StructType\BpSaleReferenceIdRequest $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->bpSaleReferenceIdRequest($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named bpDynamicPayRequest
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Bank\Mellat\StructType\BpDynamicPayRequest $parameters
     * @return \Bank\Mellat\StructType\BpDynamicPayRequestResponse|bool
     */
    public function bpDynamicPayRequest(\Bank\Mellat\StructType\BpDynamicPayRequest $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->bpDynamicPayRequest($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named bpInquiryRequest
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Bank\Mellat\StructType\BpInquiryRequest $parameters
     * @return \Bank\Mellat\StructType\BpInquiryRequestResponse|bool
     */
    public function bpInquiryRequest(\Bank\Mellat\StructType\BpInquiryRequest $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->bpInquiryRequest($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named bpSettleRequest
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Bank\Mellat\StructType\BpSettleRequest $parameters
     * @return \Bank\Mellat\StructType\BpSettleRequestResponse|bool
     */
    public function bpSettleRequest(\Bank\Mellat\StructType\BpSettleRequest $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->bpSettleRequest($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named bpChargePayRequest
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Bank\Mellat\StructType\BpChargePayRequest $parameters
     * @return \Bank\Mellat\StructType\BpChargePayRequestResponse|bool
     */
    public function bpChargePayRequest(\Bank\Mellat\StructType\BpChargePayRequest $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->bpChargePayRequest($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named bpCumulativeDynamicPayRequest
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Bank\Mellat\StructType\BpCumulativeDynamicPayRequest $parameters
     * @return \Bank\Mellat\StructType\BpCumulativeDynamicPayRequestResponse|bool
     */
    public function bpCumulativeDynamicPayRequest(\Bank\Mellat\StructType\BpCumulativeDynamicPayRequest $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->bpCumulativeDynamicPayRequest($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named bpPayRequest
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Bank\Mellat\StructType\BpPayRequest $parameters
     * @return \Bank\Mellat\StructType\BpPayRequestResponse|bool
     */
    public function bpPayRequest(\Bank\Mellat\StructType\BpPayRequest $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->bpPayRequest($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named bpRefundInquiryRequest
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Bank\Mellat\StructType\BpRefundInquiryRequest $parameters
     * @return \Bank\Mellat\StructType\BpRefundInquiryRequestResponse|bool
     */
    public function bpRefundInquiryRequest(\Bank\Mellat\StructType\BpRefundInquiryRequest $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->bpRefundInquiryRequest($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named bpReversalRequest
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Bank\Mellat\StructType\BpReversalRequest $parameters
     * @return \Bank\Mellat\StructType\BpReversalRequestResponse|bool
     */
    public function bpReversalRequest(\Bank\Mellat\StructType\BpReversalRequest $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->bpReversalRequest($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named bpPosRefundRequest
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Bank\Mellat\StructType\BpPosRefundRequest $parameters
     * @return \Bank\Mellat\StructType\BpPosRefundRequestResponse|bool
     */
    public function bpPosRefundRequest(\Bank\Mellat\StructType\BpPosRefundRequest $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->bpPosRefundRequest($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named bpVerifyRequest
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Bank\Mellat\StructType\BpVerifyRequest $parameters
     * @return \Bank\Mellat\StructType\BpVerifyRequestResponse|bool
     */
    public function bpVerifyRequest(\Bank\Mellat\StructType\BpVerifyRequest $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->bpVerifyRequest($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named bpRefundVerifyRequest
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \Bank\Mellat\StructType\BpRefundVerifyRequest $parameters
     * @return \Bank\Mellat\StructType\BpRefundVerifyRequestResponse|bool
     */
    public function bpRefundVerifyRequest(\Bank\Mellat\StructType\BpRefundVerifyRequest $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->bpRefundVerifyRequest($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \Bank\Mellat\StructType\BpChargePayRequestResponse|\Bank\Mellat\StructType\BpCumulativeDynamicPayRequestResponse|\Bank\Mellat\StructType\BpDynamicPayRequestResponse|\Bank\Mellat\StructType\BpInquiryRequestResponse|\Bank\Mellat\StructType\BpPayRequestResponse|\Bank\Mellat\StructType\BpPosRefundRequestResponse|\Bank\Mellat\StructType\BpRefundInquiryRequestResponse|\Bank\Mellat\StructType\BpRefundRequestResponse|\Bank\Mellat\StructType\BpRefundVerifyRequestResponse|\Bank\Mellat\StructType\BpReversalRequestResponse|\Bank\Mellat\StructType\BpSaleReferenceIdRequestResponse|\Bank\Mellat\StructType\BpSettleRequestResponse|\Bank\Mellat\StructType\BpVerifyRequestResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
