<?php

namespace Bank\Mellat\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for bpPosRefundRequest StructType
 * Meta information extracted from the WSDL
 * - type: tns:bpPosRefundRequest
 * @subpackage Structs
 */
class BpPosRefundRequest extends AbstractStructBase
{
    /**
     * The user
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $user;
    /**
     * The password
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The saleReferenceId
     * @var int
     */
    public $saleReferenceId;
    /**
     * The refundAmount
     * @var int
     */
    public $refundAmount;
    /**
     * Constructor method for bpPosRefundRequest
     * @uses BpPosRefundRequest::setUser()
     * @uses BpPosRefundRequest::setPassword()
     * @uses BpPosRefundRequest::setSaleReferenceId()
     * @uses BpPosRefundRequest::setRefundAmount()
     * @param string $user
     * @param string $password
     * @param int $saleReferenceId
     * @param int $refundAmount
     */
    public function __construct($user = null, $password = null, $saleReferenceId = null, $refundAmount = null)
    {
        $this
            ->setUser($user)
            ->setPassword($password)
            ->setSaleReferenceId($saleReferenceId)
            ->setRefundAmount($refundAmount);
    }
    /**
     * Get user value
     * @return string|null
     */
    public function getUser()
    {
        return $this->user;
    }
    /**
     * Set user value
     * @param string $user
     * @return \Bank\Mellat\StructType\BpPosRefundRequest
     */
    public function setUser($user = null)
    {
        // validation for constraint: string
        if (!is_null($user) && !is_string($user)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($user, true), gettype($user)), __LINE__);
        }
        $this->user = $user;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \Bank\Mellat\StructType\BpPosRefundRequest
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get saleReferenceId value
     * @return int|null
     */
    public function getSaleReferenceId()
    {
        return $this->saleReferenceId;
    }
    /**
     * Set saleReferenceId value
     * @param int $saleReferenceId
     * @return \Bank\Mellat\StructType\BpPosRefundRequest
     */
    public function setSaleReferenceId($saleReferenceId = null)
    {
        // validation for constraint: int
        if (!is_null($saleReferenceId) && !(is_int($saleReferenceId) || ctype_digit($saleReferenceId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($saleReferenceId, true), gettype($saleReferenceId)), __LINE__);
        }
        $this->saleReferenceId = $saleReferenceId;
        return $this;
    }
    /**
     * Get refundAmount value
     * @return int|null
     */
    public function getRefundAmount()
    {
        return $this->refundAmount;
    }
    /**
     * Set refundAmount value
     * @param int $refundAmount
     * @return \Bank\Mellat\StructType\BpPosRefundRequest
     */
    public function setRefundAmount($refundAmount = null)
    {
        // validation for constraint: int
        if (!is_null($refundAmount) && !(is_int($refundAmount) || ctype_digit($refundAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($refundAmount, true), gettype($refundAmount)), __LINE__);
        }
        $this->refundAmount = $refundAmount;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Bank\Mellat\StructType\BpPosRefundRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
